DECLARE SUB wave ()
'                            Morse Code Emulator
'                               by Sen Byrne
'                         
'                Program created 17-1-'98, finished 18-1-'98
'
'
'  The file called MORSE.DAT contains all the morse code itself and can be
'                       modified for more characters.
'
'
' This program has built in speed and pitch modification menus for adjusting
'                       the sound of the morse code.
'
'
'
'
'   If you want to modify this program, make sure you make a Backup first.
'                                   1998                    
'
'
DECLARE SUB SetView ()
DECLARE SUB Morse ()
DECLARE SUB Show ()
DECLARE SUB Settings ()
DECLARE SUB setup ()
DECLARE SUB Title2 ()
DECLARE SUB Title ()
DIM SHARED Morse2$(255): Morse2$(32) = "="
DIM SHARED speed, dot, dash, pause, space, pitch, a$, d, c, n$, test, bb
DIM SHARED speed2, dot2, dash2, pause2, space2, pitch2, bb2, filenf

CALL setup
DO
  CALL Title
  PRINT
  PRINT : COLOR 4
  PRINT "               Main Menu"
  PRINT "               ": COLOR 2
  PRINT "  1 - Change speed/pitch settings"
  PRINT
  PRINT "  2 - Play morse code"
  PRINT
  PRINT "  3 - Show Morse characters on screen"
  PRINT
  PRINT "  4 - Wave to morse convert"
  PRINT
  PRINT "  Q - Quit"
  PRINT : COLOR 6
  PRINT "Which? "; : COLOR 7
  DO
    k$ = INKEY$
  LOOP UNTIL k$ <> ""
  k$ = UCASE$(k$)
  IF k$ = "1" THEN CALL Settings: k$ = ""
  IF k$ = "2" THEN CALL Morse: k$ = ""
  IF k$ = "3" THEN CALL Show: k$ = ""
  IF k$ = "4" THEN CALL wave: k$ = ""
LOOP UNTIL k$ = "Q"
SYSTEM

SUB Morse
DO
  IF test = 0 THEN
    CLS
    CALL Title: COLOR 2
    PRINT "Press Enter for Main Menu"
    PRINT : COLOR 6
    PRINT "Type a line to play: "
    PRINT ">"; : COLOR 7: LINE INPUT "", a$
  END IF
  SOUND 0, 1
  FOR x = 1 TO LEN(a$)
    m$ = Morse2$(ASC(MID$(a$, x)))
    PRINT MID$(a$, x, 1);
    FOR y = 1 TO LEN(m$)
      SELECT CASE MID$(m$, y, 1)
      CASE "."
        SOUND pitch, dot / speed
        SOUND 0, bb / speed
      CASE "-"
        SOUND pitch, dash / speed
        SOUND 0, bb / speed
      CASE "="
        SOUND 0, space / speed
        SOUND 0, bb / speed
      END SELECT
    NEXT y
    SOUND 0, pause / speed
  NEXT x
LOOP UNTIL a$ = "" OR test > 0
END SUB

SUB Settings
DO
  CALL Title
  PRINT
  PRINT : COLOR 4
  PRINT "         Length/pitch settings"
  PRINT : COLOR 2
  PRINT "  1 - Change Pitch of sound"
  PRINT
  PRINT "                   --. ..---   .-"
  PRINT "                          "
  PRINT "  Change length of 2  3 4    5"
  PRINT
  PRINT "  6 - Change pause between beeps."
  PRINT
  PRINT "  7 - Change speed of morse code."
  PRINT
  PRINT "  8 - Test settings"
  PRINT
  PRINT "  Q - Main Menu"
  PRINT : COLOR 6
  PRINT "Which?";
  DO
    k$ = INKEY$
  LOOP UNTIL k$ <> ""
  CLS
  CALL Title
  COLOR 5
  SELECT CASE k$
  CASE "1"
    CALL Title: COLOR 5
    PRINT "Pitch Change"
    d = pitch2
    c = pitch
    n$ = "PITCH"
    CALL SetView
    pitch = c
  CASE "2"
    CALL Title: COLOR 5
    PRINT "Dash length change"
    d = dash2
    c = dash
    n$ = "DASH"
    CALL SetView
    dash = c
  CASE "3"
    CALL Title: COLOR 5
    PRINT "Length of pause between code change"
    d = pause2
    c = pause
    n$ = "PAUSE"
    CALL SetView
    pause = c
  CASE "4"
    CALL Title: COLOR 5
    PRINT "Dot length change"
    d = dot2
    c = dot
    n$ = "DOT"
    CALL SetView
    dot = c
  CASE "5"
    CALL Title: COLOR 5
    PRINT "Space pause length change"
    d = space2
    c = space
    n$ = "SPACE"
    CALL SetView
    space = c
  CASE "6"
    CALL Title: COLOR 5
    PRINT "Length of pause between beeps change"
    d = bb2
    c = bb
    n$ = "BB"
    CALL SetView
    bb = c
  CASE "7"
    CALL Title: COLOR 5
    PRINT "Speed of morse code change."
    d = speed2
    c = speed
    n$ = "SPEED"
    CALL SetView
    speed = c
  CASE "8"
    a$ = "This is a test."
    PRINT "Playing: "; a$
    test = 1: CALL Morse
    test = 0
  END SELECT
LOOP UNTIL UCASE$(k$) = "Q"
END SUB

SUB setup
OPEN "i", #1, "morse.dat"
f = 0: speed = 1: dot = 2: dash = 4: pause = 2: space = 4: pitch = 1000: bb = .7
speed2 = speed: dot2 = dot: dash2 = dash: pause2 = pause: space2 = space: pitch2 = pitch: bb2 = bb
DO
  LINE INPUT #1, a$
  IF UCASE$(a$) = "[MORSE]" THEN f = 1: EXIT DO
LOOP UNTIL EOF(1)
IF f = 0 AND EOF(1) THEN PRINT "Morse code not found in morse.dat": END
f = 0
DO
  DO
    LINE INPUT #1, a$
  LOOP UNTIL a$ <> ""
  c = ASC(LEFT$(a$, 1))
  IF c = 91 THEN EXIT DO
  DO
    Morse2$(c) = MID$(a$, 3)
    IF c < 65 OR c > 90 THEN EXIT DO ELSE c = c + 32
  LOOP
LOOP
CLOSE #1: OPEN "i", #1, "morse.dat"
DO
  LINE INPUT #1, a$
  IF UCASE$(a$) = "[SPEED]" THEN f = 1: EXIT DO
LOOP UNTIL EOF(1)
IF f = 0 AND EOF(1) THEN PRINT "[SPEED] not found in morse.dat": END
DO
  IF EOF(1) THEN EXIT DO
  LINE INPUT #1, a$
  IF INSTR(a$, "=") > 1 THEN
    b$ = UCASE$(LEFT$(a$, INSTR(a$, "=") - 2))
    c$ = MID$(a$, INSTR(a$, "=") + 2)
  END IF
  SELECT CASE b$
  CASE "DOT"
    dot = VAL(c$)
  CASE "DASH"
    dash = VAL(c$)
  CASE "SPEED"
    speed = VAL(c$)
  CASE "SPACE"
    space = VAL(c$)
  CASE "PAUSE"
    pause = VAL(c$)
  CASE "PITCH"
    pitch = VAL(c$)
  CASE "BB"
    bb = VAL(c$)
  END SELECT
LOOP UNTIL LEFT$(a$, 1) = "[" OR EOF(1)
CLOSE #1

END SUB

SUB SetView
  COLOR 2
  PRINT "Default value = "; d
  PRINT "Current value = "; c
  PRINT : COLOR 1
  PRINT "Press 'D' and enter to use Default value";
  PRINT "Press Enter to use Current value"
  PRINT : COLOR 4
  INPUT "New value = "; v$
  IF UCASE$(v$) = "D" THEN
    c = d
  ELSE
    IF v$ <> "" THEN c = VAL(v$)
  END IF
  OPEN "i", #1, "morse.dat"
  OPEN "o", #2, "Morse2.dat"
  DO
    LINE INPUT #1, a$
    PRINT #2, a$
    IF UCASE$(a$) = "[SPEED]" THEN EXIT DO
  LOOP: sc = 0
  DO
    LINE INPUT #1, a$: b$ = "": c$ = ""
    IF INSTR(a$, "=") > 0 THEN
      b$ = LEFT$(a$, INSTR(a$, "=") - 2)
      c$ = MID$(a$, INSTR(a$, "=") + 2)
    END IF
    IF b$ = n$ THEN
      PRINT #2, n$; " = "; MID$(STR$(c), 2): sc = 1
    ELSE
      IF (LEFT$(a$, 1) = "[" OR EOF(1)) AND sc = 0 THEN
        PRINT #2, n$; " = "; MID$(STR$(c), 2): sc = 1
        IF LEFT$(a$, 1) = "[" OR EOF(1) THEN PRINT #2, a$
      ELSE
        PRINT #2, a$
      END IF
    END IF
  LOOP UNTIL EOF(1) OR LEFT$(a$, 1) = "["
  IF EOF(1) <> -1 THEN
    DO
      LINE INPUT #1, a$
      PRINT #2, a$
    LOOP UNTIL EOF(1)
  END IF
  CLOSE #1
  CLOSE #2
  OPEN "o", #1, "morse.bak": CLOSE #1
  KILL "morse.bak"
  NAME "morse.dat" AS "morse.bak"
  NAME "morse2.dat" AS "morse.dat"
END SUB

SUB Show
  CALL Title2: COLOR 5: PRINT "Morse character set:": COLOR 7
  FOR x = 0 TO 255
    IF Morse2$(x) <> "" AND x <> 32 AND (x < 97 OR x > 122) THEN
      PRINT CHR$(x); " = "; Morse2$(x),
    END IF
  NEXT x
  PRINT : PRINT : COLOR 2
  PRINT "Press a key to continue. . .";
  DO
  LOOP UNTIL INKEY$ <> ""
END SUB

SUB Title
  WIDTH 40
  CLS : COLOR 3
  PRINT "          Morse Code emulator"
  PRINT "             by Sen Byrne"
  PRINT : COLOR 7
END SUB

SUB Title2
  WIDTH 80
  CLS : COLOR 3
  PRINT "                              Morse Code emulator"
  PRINT "                                 by Sen Byrne"
  PRINT : COLOR 7
END SUB

SUB wave
REM 59 riff
CLS
INPUT "Name of wave file: ", a$
IF a$ = "" THEN EXIT SUB
OPEN "b", #1, a$
' Sen = Sensitivity
' Sp = Speed
' In = Interference
' cs = Code skip
' ac = Accurate
' sac = Space Accurate
a$ = "    ": sen = 32: sp = 10: in = 5: cs = 5: ac = 25: sac = 40
GET #1, 1, a$
IF a$ <> "RIFF" THEN
  PRINT "This is not a normal .wav file, results may not appear properly."
END IF
n = 59: a$ = " "

PRINT "Reading lengths, please wait..."
GOSUB lenofcode
old = c
DO
  GOSUB lenofspace: GOSUB lenofcode
  c1 = c / 2
  c2 = c * 2
LOOP UNTIL (c1 + c1 * (ac / 100)) >= old OR (c2 - c2 * (ac / 100)) <= old
IF c > old THEN
  mdot = old
  mdash = c
ELSE
  mdot = c
  mdash = old
END IF

CLS
PRINT "Output:"
n = 1: code$ = ""
DO
  GOSUB lenofcode: IF er = 1 THEN EXIT DO
  IF c > mdash - mdash * (ac / 100) THEN
    code$ = code$ + "-"
  ELSE
    code$ = code$ + "."
  END IF
  GOSUB lenofspace: IF er = 1 THEN EXIT DO
  IF c > mdot - mdot * (sac / 100) THEN
    FOR x = 0 TO 255
      IF Morse2$(x) = code$ THEN PRINT CHR$(x); : EXIT FOR
    NEXT x
    IF x = 256 THEN
      PRINT "<"; code$; ">";
    END IF
    code$ = ""
  END IF
  IF c > mdash - mdash * (sac / 100) THEN
    PRINT " ";
  END IF
LOOP UNTIL n > LOF(1)
CLOSE #1
GOTO skip

lenofcode:
  c = 0
  DO
    a = 0
    FOR x = 0 TO sp
      n = n + cs: GET #1, n, a$: IF a < ASC(a$) THEN a = ASC(a$)
    NEXT x
    IF a >= 128 + sen THEN c = c + 1
    IF n > LOF(1) THEN er = 1: EXIT DO
  LOOP UNTIL a < 128 + sen AND c >= in
RETURN

lenofspace:
  c = 0
  DO
    a = 0
    FOR x = 0 TO sp
      n = n + cs: GET #1, n, a$: IF a < ASC(a$) THEN a = ASC(a$)
    NEXT x
    IF a <= 128 + sen THEN c = c + 1
    IF n > LOF(1) THEN er = 1: EXIT DO
  LOOP UNTIL a > 128 + sen AND c >= in
RETURN

skip:
PRINT : PRINT
PRINT "Press a key. . ."
DO
LOOP UNTIL INKEY$ <> ""
END SUB

